title: Boundary condition file

Although the boundary conditions are already defined in the layout.md file, it is not possible to define a particular value to the state variable on a boundary face.
In order to defined a fixed value at the boundary face you can use the boundary condition file. Once `layout.md` file is defined, the boundary condition file can be created using following command in the `system/mesh/layout/` directory:

```
$. compile.sh generate_bc.cpp
$./a.out
```
For each block a separate boundary condition files is written in `system/mesh/bc/`. The sample boundary condition is as follows:

```
BOUNDARY CONDITIONS CONFIGURATION 
================================= 

# imn
- INTERFACE

# imx
- COPY_DENSITY
- COPY_X_SPEED
- COPY_Y_SPEED
- COPY_Z_SPEED
- FIX_PRESSURE

# jmn
- COPY_DENSITY
- COPY_PRESSURE
- NO_SLIP
- WALL_TEMPERATURE

# jmx
- INTERFACE

# kmn
- COPY_DENSITY
- COPY_PRESSURE
- FLOW_TANGENCY

# kmx
- COPY_DENSITY
- COPY_PRESSURE
- FLOW_TANGENCY

FIN
```

In order to fix the value of a particular variable, depending on the boundary condition type, just input the value in front of `Fix_var` line. For example, at `imx` boundary, the back pressure is fixed to 101325 Pa. So the boundary condition file is change to :

```
BOUNDARY CONDITIONS CONFIGURATION 
================================= 

# imn
- INTERFACE

# imx
- COPY_DENSITY
- COPY_X_SPEED
- COPY_Y_SPEED
- COPY_Z_SPEED
- FIX_PRESSURE 101325

# jmn
- COPY_DENSITY
- COPY_PRESSURE
- NO_SLIP
- WALL_TEMPERATURE

# jmx
- INTERFACE

# kmn
- COPY_DENSITY
- COPY_PRESSURE
- FLOW_TANGENCY

# kmx
- COPY_DENSITY
- COPY_PRESSURE
- FLOW_TANGENCY

FIN
```
Input value only in SI units.
